<h1 id="modal">Modal</h1>
<p>Modal is a component that is overlaid on top of other site content and prevents users from interacting with content outside of it.</p>
<p>Modal conforms to the <a href="https://www.w3.org/WAI/ARIA/apg/patterns/dialogmodal/">W3C WAI-ARIA authoring practices</a>.</p>
<h2 id="set-up">Set up</h2>
<p>First import the styles into your main SASS file, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/modal/modal';
</code></pre>
<p>Alternatively <em>ace.scss</em> includes all ACE component SASS files, so if using multiple ACE components it can be imported instead:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/ace';
</code></pre>
<p>A CSS file is also provided for convenience and is located at <code>&lt;path-to-node_modules&gt;/@potato/ace/components/modal/ace-modal.css</code>.</p>
<p>Then import the class into your JavaScript entry point:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/modal/modal';
</code></pre>
<p>For convenience the ES6 class is exported as <code>Modal</code> and the attribute names used by the class are exported as properties of <code>ATTRS</code>.</p>
<p>After the event <code>DOMContentLoaded</code> is fired on <code>document</code> an instance of Modal is instantiated within each <code>&lt;ace-modal&gt;</code> element and an ID <code>ace-modal-&lt;n&gt;</code> is added for any instance without one, where <code>&lt;n&gt;</code> is a unique integer. Once instantiation is complete a custom event <code>ace-modal-ready</code> is dispatched to <code>window</code>. See the <strong>Custom events</strong> section below for more details.</p>
<p>Visible Modals take up the full screen on mobile, and have a fixed width and height for all other devices as well as a backdrop that overlays site content outside the Modal, visually obscuring it. Modal uses any element on the page with attribute <code>ace-modal-backdrop</code> as the backdrop. If no element has this attribute then an <code>&lt;div&gt;</code> element will be appended to <code>body</code> and given this attribute.</p>
<p>Modal must have at least one button to hide it. Modal will look for a descendant with attribute <code>ace-modal-hide-btn</code> and if none are present it will add a <code>&lt;button&gt;</code> element as it's first child and will give it this attribute.</p>
<p>It is strongly recommended that Modal be provided with an accessible label using either <code>aria-label</code> or <code>aria-labelledby</code>.</p>
<h2 id="usage">Usage</h2>
<p>Modals are hidden by default but can be initially shown on page load by adding the <code>ace-modal-visible</code> attribute to them, which is an observed attribute that can be added or removed to dynamically show or hide the Modal. When a Modal is shown the first focusable descendant is focused, and when hidden focus returns to the element that was focused before the Modal was shown, which in most cases is the trigger.</p>
<p>The attribute <code>ace-modal-trigger-for</code> must be added to elements that trigger the Modal with its value set to the Modal ID. For accessibility reasons it is recommended that only <code>&lt;button&gt;</code> elements are used for triggers. Modals can contain triggers for other Modals, which when clicked will hide the Modal they are in and show their target Modal. When a Modal becomes visible the attribute <code>ace-modal-is-visible</code> is added to <code>body</code> and the backdrop to pervent scrolling in the former and show the latter. Modals can be hidden by either clicking on any descendant with attribute <code>ace-modal-hide-btn</code>, clicking on the backdrop element or pressing <kbd>Esc</kbd>. When a Modal is hidden it still remains in the DOM with its content unchanged.</p>
<p>Visible Modals prevent users from interacting with content outside of it by either visually obscuring the content using the backdrop element or taking up the full screen of mobile devices, and by either making the content inert or by trapping keyboard focus within itself. Modal first attempts to use the <a href="https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement/inert">HTML <code>inert</code> property</a>, currently part of the <a href="https://html.spec.whatwg.org/multipage/interaction.html#inert-subtrees">HTML Living Standard specification</a>. If the browser supports <code>inert</code> and the Modal is a direct child of <code>body</code> it will add the <code>inert</code> attribute to all of its siblings except the backdrop, thereby preventing users from interacting with them. For browsers that don't support inert or for Modals that are not children of <code>body</code>, a fallback focus trap technique is used. This method involves determining Modal's first and last interactable descendants by getting all its focusable descendants and filtering out elements that are disabled or hidden using CSS declarations <code>display: none</code> or <code>visibility: hidden</code>. Focus can then be moved to the first interactable descendant from the last when <kbd>Tab</kbd> is pressed, and to the last from the first when <kbd>Shift</kbd> + <kbd>Tab</kbd> are pressed. To allow for dynamically changing focusable descendants the focus trap listens for changes to the <code>style</code>, <code>class</code> and <code>disabled</code> attributes of all Modal's focusable descendants using a <a href="https://developer.mozilla.org/en-US/docs/Web/API/MutationObserver">mutation observer</a> and updates the first and last interactable descendants. An example use case for this is having a disabled form submission button as the last focusable descendant, which is enabled upon form validation thereby becoming the last interactable descendant due to the mutation observer, without which this button would be unfocusable. The first and last interactable descendants can also be manually updated by developers through a custom event. See the <strong>Custom events</strong> section below for more details.</p>
<h2 id="alert-modals">Alert Modals</h2>
<p>Modals can be used as alert dialogs that interrupt the user's workflow to communicate an important message and acquire a response. Examples include action confirmation prompts and error message confirmations. To create an alert Modal simply set its <code>role</code> attribute to <code>alertdialog</code>. This enables assistive technologies and browsers to distinguish alert dialogs from other dialogs so they have the option of giving alert dialogs special treatment, such as playing a system alert sound. Modals with <code>role=&quot;alertdialog&quot;</code> will not be given <code>role=&quot;dialog&quot;</code> during initialisation.</p>
<h2 id="styles">Styles</h2>
<p>The following SASS is applied to Modal. The SASS variables use <code>!default</code> so can also be easily overridden by developers. SASS variables used that are not defined here are defined in <em>&lt;path-to-node_modules&gt;/@potato/ace/common/constants.scss</em>.</p>
<pre><code class="language-scss">@import '../../common/constants';


// VARIABLES
$ace-modal-backdrop-bg-color: rgba(0, 0, 0, .5) !default;
$ace-modal-bg-color: #fff !default;
$ace-modal-padding: $ace-spacing-3 !default;
$ace-modal-switch-breakpoint: 768px !default;


// STYLES
ace-modal {
	background: $ace-modal-bg-color;
	overflow: auto;
	padding: $ace-modal-padding;
	position: fixed;
	z-index: $ace-modal-z-index;

	@media (max-width: #{$ace-modal-switch-breakpoint - 1px}) {
		height: 100vh;
		left: 0;
		top: 0;
		width: 100vw;
	}

	@media (min-width: #{$ace-modal-switch-breakpoint}) {
		left: 50%;
		top: 50%;
		transform: translate(-50%, -50%);
	}

	&amp;:not([ace-modal-visible]) {
		// Using 'display: none' prevents VoiceOver from being able to focus within the modal
		visibility: hidden;
	}
}

// Placed on body and backdrop when a Modal is visible
[ace-modal-is-visible] {
	overflow: hidden;
	// prevent reflow due to scroll bar disappearing;
	padding-right: $ace-scrollbar-width;
}

[ace-modal-backdrop] {
	background: $ace-modal-backdrop-bg-color;
	bottom: 0;
	left: 0;
	position: fixed;
	right: 0;
	top: 0;
	z-index: $ace-modal-backdrop-z-index;

	&amp;:not([ace-modal-is-visible]) {
		display: none;
	}
}
</code></pre>
<h2 id="custom-events">Custom events</h2>
<p>Modal uses the following custom events, the names of which are available in its exported <code>EVENTS</code> object, similar to <code>ATTRS</code>, so they may be imported into other modules.</p>
<h3 id="dispatched-events">Dispatched events</h3>
<p>The following events are dispatched to <code>window</code> by Modal.</p>
<h4 id="ready">Ready</h4>
<p><code>ace-modal-ready</code></p>
<p>This event is dispatched when Modal finishes initialising. The event name is available as <code>EVENTS.OUT.READY</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Modal [string]
}
</code></pre>
<h4 id="visibility-changed">Visibility changed</h4>
<p><code>ace-modal-visibility-changed</code></p>
<p>This event is dispatched when Modal finishes initialising. The event name is available as <code>EVENTS.OUT.VISIBILITY_CHANGED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Modal [string]
	'visible': // Whether the Modal is visible or not [boolean]
}
</code></pre>
<h3 id="listened-for-event">Listened for event</h3>
<p>Modal listens for the following event that should be dispatched to <code>window</code>.</p>
<h4 id="update-focus-trap">Update focus trap</h4>
<p><code>ace-disclosure-update-focus-trap</code></p>
<p>This event should be dispatched when an element is dynamically added to the Modal as its first or last focusable descendant and updates the focus trap accordingly. The event name is available as <code>EVENTS.IN.UPDATE_FOCUS_TRAP</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Modal [string]
}
</code></pre>
<h2 id="examples">Examples</h2>
<p>Each example contains a live demo and the HTML code that produced it. The code shown may differ slightly to that rendered for the demo as some components may alter their HTML when they initialise.</p>
<h3 id="simple-modal">Simple Modal</h3>
<p>Example of a simple modal with two triggers that is shown on page load. The example also demonstrates how the focus trap and the <code>ace-disclosure-update-focus-trap</code> custom event work. After triggering the Modal, use <strong>Toggle disabled button</strong> button to toggle the disabled state of the disabled button, and notice that the mutation observer updates the focus trap. Next use the <strong>Add link to Modal</strong> and <strong>Remove link from Modal</strong> buttons to add and remove links and dispatch the custom event, and notice how the focus trap is again updated.</p>
<p>The JavaScript used by this example is shown below.</p>
<div class="example-block"><button ace-modal-trigger-for="ace-visible-modal">Modal trigger 1</button>
<button ace-modal-trigger-for="ace-visible-modal">Modal trigger 2</button>
<ace-modal aria-label="Example Modal" id="ace-visible-modal" ace-modal-visible>
	<h3>Modal heading</h3>
	<p>This modal was shown on page load because it had attribute <code>ace-modal-visible</code> when the page was loaded.</p>
	<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
	<button id="toggle-disabled-btn-btn">Toggle disabled button</button>
	<button id="add-link-btn">Add link to Modal</button>
	<button id="remove-link-btn">Remove link from Modal</button>
	<button id="disabled-btn" disabled>Disabled Button</button>
</ace-modal>
</div>
<pre><code class="language-html">&lt;button ace-modal-trigger-for=&quot;ace-visible-modal&quot;&gt;Modal trigger 1&lt;/button&gt;
&lt;button ace-modal-trigger-for=&quot;ace-visible-modal&quot;&gt;Modal trigger 2&lt;/button&gt;

&lt;ace-modal aria-label=&quot;Example Modal&quot; id=&quot;ace-visible-modal&quot; ace-modal-visible&gt;
	&lt;h3&gt;Modal heading&lt;/h3&gt;
	&lt;p&gt;This modal was shown on page load because it had attribute &lt;code&gt;ace-modal-visible&lt;/code&gt; when the page was loaded.&lt;/p&gt;
	&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
	&lt;button id=&quot;toggle-disabled-btn-btn&quot;&gt;Toggle disabled button&lt;/button&gt;
	&lt;button id=&quot;add-link-btn&quot;&gt;Add link to Modal&lt;/button&gt;
	&lt;button id=&quot;remove-link-btn&quot;&gt;Remove link from Modal&lt;/button&gt;
	&lt;button id=&quot;disabled-btn&quot; disabled&gt;Disabled Button&lt;/button&gt;
&lt;/ace-modal&gt;
</code></pre>
<pre><code class="language-js">import {EVENTS} from '/ace/components/modal/modal.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const MODAL_ID = 'ace-visible-modal';
	const modalEl = document.getElementById(MODAL_ID);
	const disabledBtn = document.getElementById('disabled-btn');

	modalEl.addEventListener('click', (e) =&gt; {
		const targetId = e.target.id;
		const toggleDisabledBtnBtnClicked = targetId === 'toggle-disabled-btn-btn';
		if (toggleDisabledBtnBtnClicked) {
			disabledBtn.disabled = !disabledBtn.disabled;
			return;
		}

		const addLinkBtnClicked = targetId === 'add-link-btn';
		if (addLinkBtnClicked) {
			const linkEl = document.createElement('a');
			linkEl.href = '#';
			linkEl.textContent = 'Dummy link';
			const pEl = document.createElement('p');
			pEl.appendChild(linkEl);
			modalEl.appendChild(pEl);
		}

		const removeLinkBtnClicked = targetId === 'remove-link-btn';
		if (removeLinkBtnClicked) {
			const linkEl = modalEl.querySelector('a');
			if (linkEl) {
				linkEl.remove();
			}
		}
		window.dispatchEvent(new CustomEvent(
			EVENTS.IN.UPDATE_FOCUS_TRAP,
			{'detail': {'id': MODAL_ID}},
		));
	});
});
</code></pre>
<h3 id="modal-that-triggers-another-modal">Modal that triggers another Modal</h3>
<p>Example of a Modal that has a trigger for another Modal and makes use of the <code>ace-modal-visibility-changed</code> custom event. When the second Modal's trigger in the first Modal is clicked, the first Modal is hidden and the second Modal shown. When the second Modal is closed and its <code>ace-modal-visibility-changed</code> custom event is dispatched, the first Modal is shown again.</p>
<p>The JavaScript used by this example is shown below.</p>
<div class="example-block"><button ace-modal-trigger-for="ace-hidden-modal">
	Second Modal's trigger
</button>
<ace-modal aria-label="Example of Modal that shows another Modal" id="ace-hidden-modal">
	<button ace-modal-hide-modal-btn aria-label="Exit modal">&#x2715;</button>
	<h3>Second Modal</h3>
	<p>Second Modal</p>
	<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
	<button ace-modal-trigger-for="ace-visible-modal">Show first modal</button>
</ace-modal>
</div>
<pre><code class="language-html">&lt;button ace-modal-trigger-for=&quot;ace-hidden-modal&quot;&gt;
	Second Modal's trigger
&lt;/button&gt;

&lt;ace-modal aria-label=&quot;Example of Modal that shows another Modal&quot; id=&quot;ace-hidden-modal&quot;&gt;
	&lt;button ace-modal-hide-modal-btn aria-label=&quot;Exit modal&quot;&gt;&amp;#x2715;&lt;/button&gt;
	&lt;h3&gt;Second Modal&lt;/h3&gt;
	&lt;p&gt;Second Modal&lt;/p&gt;
	&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
	&lt;button ace-modal-trigger-for=&quot;ace-visible-modal&quot;&gt;Show first modal&lt;/button&gt;
&lt;/ace-modal&gt;
</code></pre>
<pre><code class="language-js">import {ATTRS, EVENTS} from '/ace/components/modal/modal.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const OTHER_MODAL_ID = 'ace-visible-modal';
	const modalEl = document.getElementById('ace-hidden-modal');
	let otherModalTriggerClicked;

	// If other Modal is shown using trigger in this Modal, show this Modal when other Modal is hidden
	const otherModalTrigger = modalEl.querySelector(`[ace-modal-trigger-for=&quot;${OTHER_MODAL_ID}&quot;]`);
	otherModalTrigger.addEventListener('click', () =&gt; otherModalTriggerClicked = true);

	window.addEventListener(EVENTS.OUT.VISIBILITY_CHANGED, (e) =&gt; {
		if (!e.detail || e.detail.id !== OTHER_MODAL_ID || e.detail.visible || !otherModalTriggerClicked) {
			return;
		}
		otherModalTriggerClicked = false;
		modalEl.setAttribute(ATTRS.VISIBLE, '');
	});
});
</code></pre>
